EnableExplicit

UsePNGImageDecoder()
UseJPEGImageDecoder()
UsePNGImageEncoder()

If Not GetPathPart(ProgramFilename()) = #PB_Compiler_Home+"Compilers\"
  SetCurrentDirectory( GetPathPart(ProgramFilename()) )
EndIf



Structure winS
  x.l
  y.l
  w.l
  h.l
  xMid.l
  yMid.l
  num.l
  hnd.l
  title.s
  style.l
EndStructure

Structure pS
  x.l
  y.l
  c.l
  cOrig.l
  h.l
EndStructure


Macro inScreen(_x,_y) ; <<NOT USED>>
  (   1 And (_x>=0 And _x<win\w And _y>=0 And _y<win\h )    )
EndMacro

Macro load()
  If IsImage(0)
    FreeImage(0)
  EndIf
  If Not LoadImage(0,openfile)
    MessageRequester("error", "!")
    End
  EndIf
  Dim p.pS(max,max)
  ResizeImage(0,max+1,max+1, #PB_Image_Smooth)
  hmax=0
  hmin=$FFFFFF
  StartDrawing( ImageOutput(0) )
    For i=0 To max
      For k=0 To max
        temp_=Point(i,k)
        p(i,k)\cOrig=temp_
        p(i,k)\h = (temp_&$FF) + (temp_&$FF00)>>8 + (temp_&$FF0000)>>16   / 3  ; << color to height
        If p(i,k)\h<hmin
          hmin=p(i,k)\h
        EndIf
        If p(i,k)\h>hmax
          hmax=p(i,k)\h
        EndIf
      Next
    Next
  StopDrawing()
  For i=0 To max
    For k=0 To max
      p(i,k)\h-hmin; << just cut off base height
    Next
  Next
  win\title=">< .."+GetFilePart(openfile)
  SetWindowTitle(win\num, win\title)
EndMacro

Macro getPositions()
  For i=0 To max
    For k=0 To max
      p(i,k)\x = win\xMid + (i-k)*2*zoom
      p(i,k)\y = win\yMid + (i+k)*zoom  -max*zoom -scale*p(i,k)\h
    Next
  Next
EndMacro

Macro getColors()
  For i=0 To max
    For k=0 To max
      If c<0
        p(i,k)\c = p(i,k)\cOrig
      Else
        p(i,k)\c = ( 10+245*p(i,k)\h/(hmax-hmin) )<<c
      EndIf
    Next
  Next
EndMacro



Define max.l=100
Define i.l, k.l
Dim p.pS(max,max)

Define win.winS
Define event.l
Define em.l
Define quit.l
Define ems.l
Define timer.l
Define mx.l
Define my.l
Define xOff.l
Define yOff.l
Define hmax.l
Define hmin.l
Define zoom.f=3.0
Define scale.f=0.1
Define openfile.s=".\map02.png"
Define savefile.s=".\plotter_screenshot.png"
Define temp_.l
Define bg.l=16 ; background-color shift
Define bgm.l  ; bg mode
Define c.l=-8 ; line-color shift
Define lines.l=1; toggle 0~1
Define knots.l=1; toggle 0~1
Define rm.l      ; release mouse (toggle 0~1)
Define showpanel.l; (return) toggle 0~1
Define FR.l, FRt.l, FR$; framerate

Declare openGUI(*p.winS)
Declare sd( s.s="", startdrawing=1) 

; ------------
InitSprite()
InitMouse()
InitKeyboard()
; ------------
openGUI(win)
openfile=OpenFileRequester("load image", openfile, "bmp; jpg; jpeg; png|*.bmp;*.png;*.jpg;*.jpeg", 0)
If Not openfile : End : EndIf
load()
getPositions()
getColors()
; ------------
MouseLocate(win\xMid,win\yMid)






;################ MAIN #################
Repeat
  event=WaitWindowEvent(50)
  ExamineKeyboard()
  ExamineMouse()

  ;{-INPUT
  mx=MouseX()
  my=MouseY()
  If MouseWheel()
    If KeyboardPushed(#PB_Key_LeftControl)
      temp_=max
      max+MouseWheel() : If max<1 : max=1 : EndIf
      zoom = temp_*zoom/max
      load()
      getPositions()
      getColors()
    ElseIf KeyboardPushed(#PB_Key_LeftShift)
      scale+MouseWheel()*0.02
      getPositions()
      getColors()
    Else
      zoom+MouseWheel() : If zoom<1 : zoom=1 : EndIf
      getPositions()
    EndIf
  EndIf

  If      KeyboardReleased(#PB_Key_Up)   :::: bg+8 ::: If bg>16 :bg=16 : EndIf
  ElseIf KeyboardReleased(#PB_Key_Down) :::: bg-8 ::: If bg<0  : bg=0 : EndIf
  ElseIf KeyboardReleased(#PB_Key_Left) ::::  c+8 ::: If c>16  : c=16 : EndIf  ::  getColors()
  ElseIf KeyboardReleased(#PB_Key_Right)::::  c-8 ::: If c<-8  : c=-8  : EndIf  ::  getColors()
  EndIf

  If KeyboardReleased(#PB_Key_L) :: lines!1 :: EndIf
  If KeyboardReleased(#PB_Key_K) :: knots!1 :: EndIf
  If KeyboardReleased(#PB_Key_M) :: rm!1 : ReleaseMouse(rm) :: EndIf
  If KeyboardReleased(#PB_Key_B) :: bgm!1 :: EndIf

  If KeyboardReleased(#PB_Key_F2); screenshot
    GrabSprite(0,0,0,win\w,win\h)
    ReleaseMouse(1)
    savefile=SaveFileRequester("save screenshot", savefile, "png|*.png", 0)
    If savefile
      SaveSprite(0,savefile,#PB_ImagePlugin_PNG)
    EndIf
    FreeSprite(0)
    ReleaseMouse(0)
  EndIf

  If KeyboardReleased(#PB_Key_F3); load
    ReleaseMouse(1)
    openfile=OpenFileRequester("load image", openfile, "bmp; jpg; jpeg; png|*.bmp;*.png;*.jpg;*.jpeg", 0)
    ReleaseMouse(0)
    If openfile
      max=100
      zoom=3.0
      scale=0.1
      xOff=0
      yOff=0
      load()
      getPositions()
      getColors()
    EndIf
    MouseLocate(win\xMid,win\yMid)
  EndIf
  
  If KeyboardReleased(#PB_Key_Return)
    showpanel!1
  EndIf
  ;}-INPUT end
  
  ems=ElapsedMilliseconds()
  Select event
    Case #PB_Event_CloseWindow
      quit=1
    Case #PB_Event_Menu
      em=EventMenu()
      Select em
        Case 0;esc
          quit=1
      EndSelect
    Default
      ;{-RENDER
      ; -------------
      ClearScreen($33<<bg);$441111)
      If Not showpanel
        xOff-MouseDeltaX()*2
        yOff-MouseDeltaY()*2
        sd("              FR            "+FR$)
        sd("              knots         "+Str((max+1)*(max+1)))
        sd("[esc]         quit")
        sd("[M]           release mouse")
        sd("[L]           toggle lines")
        sd("[K]           toggle knots")
        sd("[B]           toggle bg mode")
        sd("[up/down]     bg color")
        sd("[left/right]  line color")
        sd("[f3]          load image")
        sd("[f2]       ;) schirm-schu")
        sd("[wheel]       hor-scale     "+StrF(zoom,2))
        sd("[shift+wheel] ver-scale     "+StrF(scale,2))
        sd("[cntrl+wheel] density       "+Str(max+1))
      EndIf

      StartDrawing( ScreenOutput() )
        If bgm
          For i=0 To win\h Step 20
            Box(0,i, win\w, 20, (i*100/win\h)<<bg )
          Next
        EndIf
        For i=0 To max
          For k=0 To max
            If lines
              If k<max
                LineXY( xOff+p(i,k)\x,  yOff+p(i,k)\y,   xOff+p(i,k+1)\x,  yOff+p(i,k+1)\y,   p(i,k)\c)
              EndIf
              If i<max
                LineXY(  xOff+p(i,k)\x,  yOff+p(i,k)\y,   xOff+p(i+1,k)\x,  yOff+p(i+1,k)\y,   p(i,k)\c)
              EndIf
            EndIf
            If knots
              ;Circle( xOff+p(i,k)\x, yOff+p(i,k)\y, 2, p(i,k)\c)
              Box( xOff+p(i,k)\x-1, yOff+p(i,k)\y-1, 3,3, p(i,k)\c)
            EndIf
          Next
        Next
        DrawImage(ImageID(0),20,win\h-max-20)
        DrawingMode(#PB_2DDrawing_Transparent)
        sd("",0)
      StopDrawing()
      If showpanel
        DisplayTransparentSprite(1,100,100)
        DisplayTransparentSprite(2,mx,my)
      EndIf
      FlipBuffers(0)
      Delay(30)
      ; -------------
      ;}-RENDER end

      FR+1 ;{-framerate
      If ElapsedMilliseconds()>FRt
        FR$=Str(FR) 
        FR=0
        FRt=ElapsedMilliseconds()+1000
      EndIf
      ;}-

  EndSelect
  ;Delay(10)
Until quit Or KeyboardPushed(#PB_Key_Escape)
;############## MAIN end ###############






Procedure openGUI(*p.winS)
  *p\num=0
  *p\title="><"
  *p\style=#PB_Window_SystemMenu
  *p\style|#PB_Window_ScreenCentered
  *p\w=800
  *p\h=600
  *p\xMid=*p\w/2
  *p\yMid=*p\h/2
  *p\hnd=OpenWindow(*p\num, 0,0, *p\w,*p\h, *p\title, *p\style)
  OpenWindowedScreen(*p\hnd, 0,0, *p\w,*p\h, 0,0,0)
  AddKeyboardShortcut(*p\num, #PB_Shortcut_Escape, 0)

  If #PB_Compiler_OS = #PB_OS_Linux
      LoadFont(0,"Monospace",8,0*#PB_Font_Bold)
  ElseIf #PB_Compiler_OS = #PB_OS_Windows
      LoadFont(0,"Lucida Console",8,0*#PB_Font_Bold)
  EndIf
  
  CreateSprite(1, 600, 400);menu
  StartDrawing( SpriteOutput(1) )
    DrawingMode(#PB_2DDrawing_Outlined)
    Box(0,0, 600,400, $555555)
  StopDrawing()

  CreateSprite(2, 12, 12); cursor
  StartDrawing( SpriteOutput(2) )
    Line(0,0, 8,12, $999999)
    Line(0,0, 12,8, $bbbbbb)
  StopDrawing()
EndProcedure


Procedure sd( s.s="", startdrawing=1)  ;##### screen debug
  Static NewList outtext.s()
  Protected y
  If s
    AddElement(outtext())
    outtext()=s
  Else
    If startdrawing
      StartDrawing( ScreenOutput() )
      DrawingMode(#PB_2DDrawing_Transparent)
      DrawingFont(FontID(0))
    EndIf
    y=15
    DrawingFont(FontID(0))
    ForEach outtext()
      DrawText(15,y,outtext(),$777777)
      y+15
    Next
    If startdrawing
      StopDrawing()
    EndIf
    ClearList(outtext())
  EndIf
EndProcedure





; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 186
; FirstLine = 105
; Folding = Ap
; Markers = 101,187
; Executable = plotter.exe